//---------------------------------------------------------------------------------------
//  MKConnectInspector.h created by erik on Tue Apr 02 2002
//  @(#)$Id: MKConnectInspector.h,v 1.2 2002/09/02 21:32:29 erik Exp $
//
//  Copyright (c) 2002 by Mulle Kybernetik. All rights reserved.
//
//  Permission to use, copy, modify and distribute this software and its documentation
//  is hereby granted, provided that both the copyright notice and this permission
//  notice appear in all copies of the software, derivative works or modified versions,
//  and any portions thereof, and that both notices appear in supporting documentation,
//  and that credit is given to Mulle Kybernetik in all documents and publicity
//  pertaining to direct or indirect use of this code or its derivatives.
//
//  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH MAY HAVE
//  SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS SOFTWARE IN ITS
//  "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY
//  DAMAGES WHATSOEVER RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE
//  OR OF ANY DERIVATIVE WORK.
//---------------------------------------------------------------------------------------

#import <InterfaceBuilder/InterfaceBuilder.h>
#import "MKConnectionType.h"

@class MKPathNode;


@interface MKConnectInspector : IBInspector
{
    id						inspectedObject;
    id						destinationObject;
    NSMutableArray			*connectionTypes;
    NSMutableArray			*connectionTypeForSocket;
    NSImage					*warningImage;

    id						destinationPathOrigin;
    MKPathNode				*destinationPathRootNode;
    
    IBOutlet NSPopUpButton 	*typePopUp;
    IBOutlet NSBrowser     	*socketBrowser;
    IBOutlet NSOutlineView	*destinationOutlineView;
    IBOutlet NSTextField	*destinationPathField;
    IBOutlet NSTableView   	*connectorTableView;
    IBOutlet NSButton      	*connectButton;
    IBOutlet NSImageView	*warningIcon;
    IBOutlet NSTextField	*warningText;
}

+ (void)registerConnectionTypeClass:(Class)cls;

- (NSArray *)connectors;
- (NSArray *)activeConnectionTypes;
- (NSString *)selectedSocketLabel;
- (MKConnectionType *)connectionTypeForSelectedSocket;
- (NSString *)selectedDestinationPath;
- (id <MKIBConnectors>)selectedConnector;

- (void)suggestSocket;
- (void)selectSocketForConnectorInSocketBrowser:(id <IBConnectors>)connector;
- (void)showAndSelectPathInDestinationOutlineView:(NSString *)path;
- (void)selectConnectorInConnectorTableView:(id <IBConnectors>)connector;

- (IBAction)selectObject:(id)sender;
- (IBAction)selectConnectDestination:(id)sender;
- (IBAction)selectConnectionType:(id)sender;
- (IBAction)selectSocket:(id)sender;
- (IBAction)dclickSocket:(id)sender;
- (IBAction)selectDestination:(id)sender;
- (IBAction)dclickDestination:(id)sender;
- (IBAction)setDestinationPath:(id)sender;
- (IBAction)selectConnector:(id)sender;
- (IBAction)connect:(id)sender;
- (IBAction)disconnect:(id)sender;

- (void)redisplayTypePopUpKeepSelection:(BOOL)selFlag;
- (void)redisplaySocketBrowserKeepSelection:(BOOL)selFlag;
- (void)redisplayDestinationOutlineViewKeepSelection:(BOOL)selFlag;
- (void)redisplayConnectorTableViewKeepSelection:(BOOL)selFlag;
- (void)redisplayButtonsAndWarning;

@end
